Subject: bug#13185: closed (Re: bug#13185: Test case 'misc/timeout-group' failed)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 18 Dec 2012 13:20:02 +0000

Your bug report

#13185: Test case 'misc/timeout-group' failed

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
13185: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=13185
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#13185: Test case 'misc/timeout-group' failed
From: Pádraig Brady <[email-masked]>
To: Stefano Lattarini <[email-masked]>
Cc: [email-masked]
Date: Tue, 18 Dec 2012 13:18:26 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

On 12/18/2012 09:45 AM, Stefano Lattarini wrote:
> On 12/18/2012 01:48 AM, Pádraig Brady wrote:
>>
>> So the skip was on purpose and to avoid signal propagation issues seen
>> on some older systems:
>> http://git.sv.gnu.org/gitweb/?p=coreutils.git;a=commit;h=v8.14-30-g6603e37
>>
>> This initial failure is worrying, though may be a false positive
>> due to your shell or something. What versions of dash, bash, kernel
>> do you have there?
>>
>
>    $ bash --version
>    GNU bash, version 4.2.36(2)-release (i686-pc-linux-gnu)
>
>    $ dpkg -l dash | sed -n '$p'
>    ii  dash  0.5.7-3  i386  POSIX-compliant shell
>
>    $ uname -rsv
>    Linux 2.6.30-2-686 #1 SMP Sat Sep 26 01:16:22 UTC 2009
>
>> I can't reproduce at all here with any shell, though you might
>> have older versions.
>>
>> What is your system /bin/sh, dash or bash?
>>
> Bash.  But the affected coreutils testsuite run was done with a
> more bleeding-edge version of bash, explicitly selected as SHELL
> (and CONFIG_SHELL).
>
>> Note you can force a particular SHELL as follows,
>> and it would be interesting to see if the issue affected all shells.
>>
> The fact is that I haven't been able to reproduce the issue after
> the first failure.  So it won't be easy to ensure whether it has
> been fixed...
>
>> make check TESTS='tests/misc/timeout-group.sh' SUBDIRS=. VERBOSE=yes SHELL=bash
>>
>> Hopefully we can come up with a skip for this case too.

I noticed a possible race in the test script.
So I'll apply this soon.

thanks,
Pádraig.

commit 09f72d285514a91495960ea3b0570251eed415b0
Author: Pádraig Brady <[email-masked]>
Date:   Tue Dec 18 13:06:15 2012 +0000

     tests: avoid a race in timeout-group.sh

     * tests/misc/timeout-group.sh: The kernel might possibly delay
     signal propagation to timeout.cmd long enough, that it exits
     normally without running the signal handler (as sleep will
     be in the same process group and so get the signal too).
     So avoid this by explicitly checking that the signal handler
     is called, which should always happen under normal circumstances.
     Reported by Stefano Lattarini on linux-2.6.30-2-686 and bash-4.2.36.

diff --git a/tests/misc/timeout-group.sh b/tests/misc/timeout-group.sh
index 4cefc33..7117abb 100755
--- a/tests/misc/timeout-group.sh
+++ b/tests/misc/timeout-group.sh
@@ -34,7 +34,11 @@ cat > timeout.cmd <<\EOF
  #!/bin/sh
  trap 'touch int.received; exit' INT
  touch timeout.running
-sleep $1
+count=$1
+until test -e int.received || test $count = 0; do
+  sleep 1
+  count=$(expr $count - 1)
+done
  EOF
  chmod a+x timeout.cmd

Subject: Test case 'misc/timeout-group' failed
From: Stefano Lattarini <[email-masked]>
To: [email-masked]
Date: Fri, 14 Dec 2012 18:28:40 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

While running the coreutils testsuite on my oldish Debian desktop with
a somewhat heavy load and several bleeding-edge tools in PATH, I've
encountered this failure in the 'tests/misc/timeout-group.sh' test:

  ++ initial_cwd_=/devel/bleeding/src/coreutils
  ++ fail=0
  +++ testdir_prefix_
  +++ printf gt
  ++ pfx_=gt
  +++ mktempd_ /devel/bleeding/src/coreutils gt-timeout-group.sh.XXXX
  +++ case $# in
  +++ destdir_=/devel/bleeding/src/coreutils
  +++ template_=gt-timeout-group.sh.XXXX
  +++ MAX_TRIES_=4
  +++ case $destdir_ in
  +++ case $template_ in
  ++++ unset TMPDIR
  +++ d=/devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  +++ case $d in
  +++ test -d /devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  ++++ ls -dgo /devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  ++++ tr S -
  +++ perms='drwx------ 2 4096 Dec 14 18:17 /devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ'
  +++ case $perms in
  +++ test 0 = 0
  +++ echo /devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  +++ return
  ++ test_dir_=/devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  ++ cd /devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  ++ gl_init_sh_nl_='
  '
  ++ IFS=' 	
  '
  ++ for sig_ in 1 2 3 13 15
  +++ expr 1 + 128
  ++ eval 'trap '\''Exit 129'\'' 1'
  +++ trap 'Exit 129' 1
  ++ for sig_ in 1 2 3 13 15
  +++ expr 2 + 128
  ++ eval 'trap '\''Exit 130'\'' 2'
  +++ trap 'Exit 130' 2
  ++ for sig_ in 1 2 3 13 15
  +++ expr 3 + 128
  ++ eval 'trap '\''Exit 131'\'' 3'
  +++ trap 'Exit 131' 3
  ++ for sig_ in 1 2 3 13 15
  +++ expr 13 + 128
  ++ eval 'trap '\''Exit 141'\'' 13'
  +++ trap 'Exit 141' 13
  ++ for sig_ in 1 2 3 13 15
  +++ expr 15 + 128
  ++ eval 'trap '\''Exit 143'\'' 15'
  +++ trap 'Exit 143' 15
  ++ trap remove_tmp_ 0
  + path_prepend_ ./src
  + test 1 '!=' 0
  + path_dir_=./src
  + case $path_dir_ in
  + abs_path_dir_=/devel/bleeding/src/coreutils/./src
  + case $abs_path_dir_ in
  + PATH=/devel/bleeding/src/coreutils/./src:/devel/bleeding/src/coreutils/src:/usr/local/bleeding/bin:/usr/local/bleeding/sbin:/home/stefano/bin/local:/home/stefano/bin:/usr/local/bin:/opt/bin:/usr/lib/jvm/java-6-sun-1.6.0.26/bin:/usr/games:/usr/bin:/usr/sbin:/bin:/sbin
  + create_exe_shims_ /devel/bleeding/src/coreutils/./src
  + case $EXEEXT in
  + return 0
  + shift
  + test 0 '!=' 0
  + export PATH
  + print_ver_ timeout
  + test yes = yes
  + local i
  + for i in '$*'
  + env timeout --version
  timeout (GNU coreutils) 8.20.63-4f62d
  Copyright (C) 2012 Free Software Foundation, Inc.
  License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
  This is free software: you are free to change and redistribute it.
  There is NO WARRANTY, to the extent permitted by law.

  Written by Padraig Brady.
  + setsid true
  + cat
  + chmod a+x timeout.cmd
  + cat
  + chmod a+x group.sh
  + setsid ./group.sh
  + retry_delay_ check_timeout_cmd_running .1 6
  + local test_func=check_timeout_cmd_running
  + local init_delay=.1
  + local max_n_tries=6
  + local attempt=1
  + local num_sleeps=1
  + local time_fail
  + test 1 -le 6
  ++ gawk -v n=1 -v s=.1 'BEGIN { print s * n }'
  + local delay=0.1
  + check_timeout_cmd_running 0.1
  + local delay=0.1
  + test -e timeout.running
  + time_fail=0
  + break
  + test 0 = 0
  + env kill -INT -- -28937
  + wait
  + test -e int.received
  + fail=1
  + rm -f int.received timeout.running
  ++ date +%s
  + start=1355505442
  + timeout -sALRM 30 timeout -sINT 25 ./timeout.cmd 20
  + pid=28946
  + retry_delay_ check_timeout_cmd_running .1 6
  + local test_func=check_timeout_cmd_running
  + local init_delay=.1
  + local max_n_tries=6
  + local attempt=1
  + local num_sleeps=1
  + local time_fail
  + test 1 -le 6
  ++ gawk -v n=1 -v s=.1 'BEGIN { print s * n }'
  + local delay=0.1
  + check_timeout_cmd_running 0.1
  + local delay=0.1
  + test -e timeout.running
  + time_fail=0
  + break
  + test 0 = 0
  + kill -ALRM 28946
  + wait 28946
  + ret=124
  + test 124 -eq 124
  + test -e int.received
  ++ date +%s
  + end=1355505442
  ++ expr 1355505442 - 1355505442
  + test 0 -lt 20
  + Exit 1
  + set +e
  + exit 1
  + exit 1
  + remove_tmp_
  + __st=1
  + cleanup_
  + :
  + cd /devel/bleeding/src/coreutils
  + chmod -R u+rwx /devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  + rm -rf /devel/bleeding/src/coreutils/gt-timeout-group.sh.ZyEZ
  + exit 1

Attached is the corresponding config.log (compressed).

I've not investigated further.  Let me know if you need more information.

Regards,
  Stefano